from .nlp import print_tree
from .parser_en import ParserEN
from .parser_de import ParserDE


def create_parser(name, lemmas=False):
    """Creates and returns a parser (as an instanceof a subclass of Parser)
    for the language specified in the parameter. Throws exception if language
    is not implemented.

    Available parsers:
    'en' -- English

    Keyword argument:
    lemmas -- if True, lemma edges are generated by the parser.
    (default: False)
    """
    if name == 'en':
        return ParserEN(lemmas=lemmas)
    if name == 'de':
        return ParserDE(lemmas=lemmas)
    else:
        raise RuntimeError('Unknown parser: {}'.format(name))
